# A bidirectionnal TCP connection that simplifies creation of UDP channels, server part

from TCPServer import *
from UDPChannel import  *
from connectionConsts import *

class connectionServer(TCPServer):
  def __init__(self, ip, port, UDPPortsBase):
    TCPServer.__init__(self, ip, port)
    self.UDPChannels = []
    self.UDPPortsBase = UDPPortsBase
    self.lastPort = UDPPortsBase - 2

  def createUDPChannel(self, clientId):
    # Check input
    clientId = int(clientId)
    if not self.clients.has_key(clientId): return
    
    # Create UDP channel
    port = self.lastPort + 2
    self.lastPort = port
    self.UDPChannels.append(UDPChannel(self.addr[0], port, self.clients[clientId].addr[0], port + 1))

    # Send a notification to client
    self.send(clientId, port, DATA_UDP_CHANNEL_CREATION)

  def send(self, clientId, data, type = DATA_DATA):
    data = "%i,%s" % (type, data)
    TCPServer.send(self, clientId, data)
 
